"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withLocalLang;

var _react = _interopRequireDefault(require("react"));

var _LangProvider = _interopRequireDefault(require("../components/LangProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
function withLocalLang(lang) {
  /**
   * wrapper - wraps component in Wrapper.
   * @function
   * @param {object} Component
   * @return object
   */
  var wrapper = function wrapper(Component) {
    var Wrapper = /*#__PURE__*/_react.default.forwardRef(function Wrapper(props, ref) {
      return /*#__PURE__*/_react.default.createElement(_LangProvider.default, {
        lang: lang
      }, /*#__PURE__*/_react.default.createElement(Component, props));
    });

    Wrapper.displayName = Component.displayName;
    return Wrapper;
  };

  return wrapper;
}