"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _hljs = require("react-syntax-highlighter/dist/cjs/styles/hljs");

var _colors = require("@material-ui/core/colors");

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _reactSyntaxHighlighter = _interopRequireDefault(require("react-syntax-highlighter"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _commonStyles = require("../../stylesheets/commonStyles");

var _core = require("@material-ui/core");

var _clsx = _interopRequireDefault(require("clsx"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-Code";
exports.displayName = displayName;

var Code = /*#__PURE__*/_react.default.forwardRef(function Code(props, _ref) {
  var children = props.children,
      _props$language = props.language,
      language = _props$language === void 0 ? "javascript" : _props$language,
      style = props.style,
      className = props.className,
      classes = props.classes,
      _props$themeDark = props.themeDark,
      themeDark = _props$themeDark === void 0 ? "dark" : _props$themeDark,
      _props$themeLight = props.themeLight,
      themeLight = _props$themeLight === void 0 ? "light" : _props$themeLight,
      other = _objectWithoutProperties(props, ["children", "language", "style", "className", "classes", "themeDark", "themeLight"]);

  var muiTheme = (0, _core.useTheme)();
  var theme = props.theme || (muiTheme.palette.type === "dark" ? themeDark : themeLight);
  var commonClasses = (0, _commonStyles.useCommonStyles)();

  var _React$useState = _react.default.useState(0),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      height = _React$useState2[0],
      setHeight = _React$useState2[1];

  var codeRef = _react.default.useRef(null);

  var rootRef = _react.default.useRef(null);

  _react.default.useEffect(function () {
    onResize();
    window.addEventListener("resize", onResize);
    return function () {
      return window.removeEventListener("resize", onResize);
    };
  }, [children, codeRef.current, rootRef.current]);

  function onResize(event) {
    var scrollbar = rootRef.current ? rootRef.current.offsetHeight - rootRef.current.clientHeight : 0;

    if (codeRef.current) {
      setHeight(codeRef.current.clientHeight + scrollbar);
    } else {
      setHeight(0);
    }
  }

  function fixStyle(style) {
    return _objectSpread({}, style, {
      hljs: _objectSpread({}, style.hljs, {
        background: 'none'
      })
    });
  }

  var codeStyles = {
    light: {
      highlight: fixStyle(_hljs.docco),
      background: _colors.grey[200]
    },
    dark: {
      highlight: fixStyle(_hljs.dark),
      background: _colors.grey[900]
    },
    darcula: {
      highlight: fixStyle(_hljs.darcula),
      background: _colors.blueGrey[900]
    }
  };
  var codeStyle = codeStyles.light;

  switch (theme) {
    case 'dark':
      codeStyle = codeStyles.dark;
      break;

    case 'darcula':
      codeStyle = codeStyles.darcula;
      break;

    default:
      codeStyle = codeStyles.light;
  }

  return /*#__PURE__*/_react.default.createElement(_Paper.default, {
    style: _objectSpread({
      backgroundColor: codeStyle.background,
      height: height
    }, style),
    className: (0, _clsx.default)(commonClasses.pageBlock, classes.root, className),
    elevation: 0,
    ref: function ref(element) {
      rootRef.current = element;
      if (_ref) _ref.current = element;
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.highlighterContainer,
    ref: codeRef
  }, /*#__PURE__*/_react.default.createElement(_reactSyntaxHighlighter.default, {
    language: language,
    style: codeStyle.highlight
  }, children)));
});

Code.displayName = displayName;
Code.propTypes = {
  // CodeProps
  theme: _propTypes.default.oneOf(["light", "dark", "darcula"]),
  language: _propTypes.default.oneOf(["1c", "abnf", "accesslog", "actionscript", "ada", "angelscript", "apache", "applescript", "arcade", "arduino", "armasm", "asciidoc", "aspectj", "autohotkey", "autoit", "avrasm", "awk", "axapta", "bash", "basic", "bnf", "brainfuck", "c-like", "c", "cal", "capnproto", "ceylon", "clean", "clojure-repl", "clojure", "cmake", "coffeescript", "coq", "cos", "cpp", "crmsh", "crystal", "csharp", "csp", "css", "d", "dart", "delphi", "diff", "django", "dns", "dockerfile", "dos", "dsconfig", "dts", "dust", "ebnf", "elixir", "elm", "erb", "erlang-repl", "erlang", "excel", "fix", "flix", "fortran", "fsharp", "gams", "gauss", "gcode", "gherkin", "glsl", "gml", "go", "golo", "gradle", "groovy", "haml", "handlebars", "haskell", "haxe", "hsp", "htmlbars", "http", "hy", "inform7", "ini", "irpf90", "isbl", "java", "javascript", "jboss-cli", "json", "julia-repl", "julia", "kotlin", "lasso", "latex", "ldif", "leaf", "less", "lisp", "livecodeserver", "livescript", "llvm", "lsl", "lua", "makefile", "markdown", "mathematica", "matlab", "maxima", "mel", "mercury", "mipsasm", "mizar", "mojolicious", "monkey", "moonscript", "n1ql", "nginx", "nim", "nix", "nsis", "objectivec", "ocaml", "openscad", "oxygene", "parser3", "perl", "pf", "pgsql", "php-template", "php", "plaintext", "pony", "powershell", "processing", "profile", "prolog", "properties", "protobuf", "puppet", "purebasic", "python-repl", "python", "q", "qml", "r", "reasonml", "rib", "roboconf", "routeros", "rsl", "ruby", "ruleslanguage", "rust", "sas", "scala", "scheme", "scilab", "scss", "shell", "smali", "smalltalk", "sml", "sqf", "sql", "stan", "stata", "step21", "stylus", "subunit", "swift", "taggerscript", "tap", "tcl", "thrift", "tp", "twig", "typescript", "vala", "vbnet", "vbscript-html", "vbscript", "verilog", "vhdl", "vim", "x86asm", "xl", "xml", "xquery", "yaml", "zephir"]),
  children: _propTypes.default.string,
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object
};

var _default = (0, _core.withStyles)(_styles.styles, {
  name: displayName
})(Code);

exports.default = _default;