"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _PagesGroupDataValidator = _interopRequireDefault(require("../../validators/PagesGroupDataValidator"));

var _getContainerByType = _interopRequireDefault(require("../../utils/getContainerByType"));

var _AutoDocsMenu = require("./../AutoDocsMenu");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-DocsMenu";
exports.displayName = displayName;

var DocsMenu = /*#__PURE__*/_react.default.forwardRef(function DocsMenu(props, ref) {
  var _props$dense = props.dense,
      dense = _props$dense === void 0 ? false : _props$dense,
      children = props.children,
      layoutData = props.layoutData,
      other = _objectWithoutProperties(props, ["dense", "children", "layoutData"]);

  var _React$useState = _react.default.useState({
    basic: [],
    auto: null
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      content = _React$useState2[0],
      setContent = _React$useState2[1];

  _react.default.useEffect(function () {
    setContent(getMenusFromChildren());
  }, [children, layoutData]);

  function getMenusFromChildren() {
    // const basicMenu = React.Children.map(children, item => {
    //     if (React.isValidElement(item) && item.type.displayName !== AutoDocsMenuDisplayName) return item;
    // }).filter(item => item) || [];
    var basicMenu = (0, _getContainerByType.default)(children, _AutoDocsMenu.displayName, true);
    var autoMenu = (0, _getContainerByType.default)(children, _AutoDocsMenu.displayName);
    if (autoMenu) autoMenu = /*#__PURE__*/_react.default.cloneElement(autoMenu, {
      layoutData: layoutData
    });
    return {
      basic: basicMenu,
      auto: autoMenu
    };
  }

  if (!layoutData) return /*#__PURE__*/_react.default.createElement(_List.default, _extends({
    dense: dense
  }, other), children);
  return /*#__PURE__*/_react.default.createElement(_List.default, _extends({
    dense: dense
  }, other), content.auto, content.basic);
});

DocsMenu.displayName = displayName;
DocsMenu.propTypes = {
  // Containerable
  dense: _propTypes.default.bool,
  children: _propTypes.default.node,
  layoutData: _PagesGroupDataValidator.default
};
var _default = DocsMenu;
exports.default = _default;