"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Collapse = _interopRequireDefault(require("@material-ui/core/Collapse"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _icons = require("@material-ui/icons");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withWidth = _interopRequireDefault(require("@material-ui/core/withWidth"));

var _styles2 = require("@material-ui/styles");

var _useNesting = _interopRequireWildcard(require("../../hooks/useNesting"));

var _useMenu2 = _interopRequireDefault(require("../../hooks/useMenu/useMenu"));

var _routingManager = require("routing-manager");

var _clsx = _interopRequireDefault(require("clsx"));

var _createRouteFromName = _interopRequireDefault(require("../../utils/createRouteFromName"));

var _core = require("@material-ui/core");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-DocsMenuItem";
exports.displayName = displayName;
var DocsMenuItem = (0, _withWidth.default)()( /*#__PURE__*/_react.default.forwardRef(function DocsMenuItem(props, ref) {
  var children = props.children,
      _props$defaultExpande = props.defaultExpanded,
      defaultExpanded = _props$defaultExpande === void 0 ? false : _props$defaultExpande,
      _props$textPrimary = props.textPrimary,
      textPrimary = _props$textPrimary === void 0 ? "" : _props$textPrimary,
      _props$textSecondary = props.textSecondary,
      textSecondary = _props$textSecondary === void 0 ? "" : _props$textSecondary,
      icon = props.icon,
      onClick = props.onClick,
      link = props.link,
      page = props.page,
      _props$isCurrent = props.isCurrent,
      isCurrent = _props$isCurrent === void 0 ? false : _props$isCurrent,
      className = props.className,
      style = props.style,
      _props$dense = props.dense,
      dense = _props$dense === void 0 ? false : _props$dense,
      width = props.width,
      classes = props.classes,
      other = _objectWithoutProperties(props, ["children", "defaultExpanded", "textPrimary", "textSecondary", "icon", "onClick", "link", "page", "isCurrent", "className", "style", "dense", "width", "classes"]);

  var theme = (0, _core.useTheme)();

  var _useChangeRoute = (0, _routingManager.useChangeRoute)(),
      changeRoute = _useChangeRoute.changeRoute,
      getRouteParams = _useChangeRoute.getRouteParams;

  var pageRoute = typeof page === "string" && (0, _createRouteFromName.default)(page);

  var _React$useState = _react.default.useState(defaultExpanded),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      expanded = _React$useState2[0],
      setExpanded = _React$useState2[1];

  var context_nesting = (0, _useNesting.default)();
  var nesting = other.nesting || context_nesting;

  var _useMenu = (0, _useMenu2.default)(),
      closeMenu = _useMenu.closeMenu;

  _react.default.useEffect(function () {
    defaultExpanded && setExpanded(defaultExpanded);
  }, [defaultExpanded]);

  var highlight = false;

  if (typeof isCurrent === "boolean") {
    highlight = isCurrent;
  } else if (typeof isCurrent === "function") {
    highlight = isCurrent(getRouteParams(), pageRoute, page);
  } else if (getRouteParams().page === pageRoute) {
    highlight = true;
  }

  var paddingShift = nesting * 2 + 2;
  if (paddingShift > 16) paddingShift = 16;

  function handleOpen() {
    setExpanded(!expanded);
  }

  function handleButtonClick(event) {
    if (typeof onClick === "function") {
      onClick(event);
    } else {
      if (typeof link === "string") {
        changeRoute({
          page: link
        });
      } else {
        if (typeof pageRoute === "string") {
          changeRoute({
            page: pageRoute
          });
        } else if (_typeof(page) === "object") {
          changeRoute(_objectSpread({}, page));
        }
      }
    }

    if (!(0, _core.isWidthUp)("md", width)) closeMenu();
  }

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_ListItem.default, _extends({
    button: true,
    onClick: children ? handleOpen : onClick || handleButtonClick
  }, other, {
    className: (0, _clsx.default)(classes.root, highlight && classes.highlighted, className),
    style: _objectSpread({
      paddingLeft: theme.spacing(paddingShift)
    }, style),
    ref: ref,
    dense: dense
  }), icon && /*#__PURE__*/_react.default.createElement(_ListItemIcon.default, null, icon), /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
    primary: textPrimary || page,
    secondary: textSecondary,
    primaryTypographyProps: {
      style: {
        fontWeight: children ? "bold" : "normal"
      }
    }
  }), children && (expanded ? /*#__PURE__*/_react.default.createElement(_icons.ExpandLess, null) : /*#__PURE__*/_react.default.createElement(_icons.ExpandMore, null))), children && /*#__PURE__*/_react.default.createElement(_Collapse.default, {
    in: expanded,
    timeout: "auto",
    unmountOnExit: true,
    className: classes.collapse,
    disableStrictModeCompat: true
  }, /*#__PURE__*/_react.default.createElement(_useNesting.NestingContext.Provider, {
    value: nesting + 1
  }, children)));
}));
DocsMenuItem.displayName = displayName;
DocsMenuItem.propTypes = {
  // DocsMenuItemProps
  defaultExpanded: _propTypes.default.bool,
  textPrimary: _propTypes.default.string,
  textSecondary: _propTypes.default.string,
  icon: _propTypes.default.node,
  onClick: _propTypes.default.func,
  page: _propTypes.default.any,
  isCurrent: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.func]),
  dense: _propTypes.default.bool,
  nesting: _propTypes.default.number,
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object,
  // Containerable
  children: _propTypes.default.node
};

var _default = (0, _styles2.withStyles)(_styles.styles, {
  name: displayName
})(DocsMenuItem);

exports.default = _default;