"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _Locale = _interopRequireDefault(require("../Locale"));

var _reactHelmetAsync = require("react-helmet-async");

var _NavigationList = _interopRequireDefault(require("./NavigationList"));

var _reactRouterDom = require("react-router-dom");

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _useSearch2 = _interopRequireDefault(require("../../hooks/useSearch"));

var _useGroups2 = _interopRequireDefault(require("../../hooks/useGroups"));

var _commonStyles = require("../../stylesheets/commonStyles");

var _styles2 = require("@material-ui/styles");

var _useTags = require("../../hooks/useTags");

var _createRouteFromName = _interopRequireDefault(require("../../utils/createRouteFromName"));

var _ = _interopRequireWildcard(require("lodash"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-DocsPage";
exports.displayName = displayName;

var DocsPage = /*#__PURE__*/_react.default.forwardRef(function DocsPage(props, ref) {
  var _props$name = props.name,
      name = _props$name === void 0 ? "home" : _props$name,
      _props$searchTags = props.searchTags,
      searchTags = _props$searchTags === void 0 ? [] : _props$searchTags,
      searchLabel = props.searchLabel,
      searchDescription = props.searchDescription,
      _props$noGenerateAuto = props.noGenerateAutoSearch,
      noGenerateAutoSearch = _props$noGenerateAuto === void 0 ? false : _props$noGenerateAuto,
      _props$noAutoMenu = props.noAutoMenu,
      noAutoMenu = _props$noAutoMenu === void 0 ? false : _props$noAutoMenu,
      width = props.width,
      children = props.children,
      classes = props.classes,
      order = props.order,
      _props$disableRoute = props.disableRoute,
      disableRoute = _props$disableRoute === void 0 ? false : _props$disableRoute,
      other = _objectWithoutProperties(props, ["name", "searchTags", "searchLabel", "searchDescription", "noGenerateAutoSearch", "noAutoMenu", "width", "children", "classes", "order", "disableRoute"]);

  var commonClasses = (0, _commonStyles.useCommonStyles)();

  var _React$useState = _react.default.useState({}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      tags = _React$useState2[0],
      setTags = _React$useState2[1];

  var _React$useState3 = _react.default.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      content = _React$useState4[0],
      setContent = _React$useState4[1];

  var _useSearch = (0, _useSearch2.default)(),
      addSearchItem = _useSearch.addSearchItem,
      removeSearchItem = _useSearch.removeSearchItem;

  var _useGroups = (0, _useGroups2.default)(),
      addPage = _useGroups.addPage,
      deletePage = _useGroups.deletePage,
      parentPath = _useGroups.path;

  var prevPage = _react.default.useRef(null);

  var prevSearchItem = _react.default.useRef(null);

  var pagePath = [].concat(_toConsumableArray(parentPath || []), [name]).map(function (name) {
    return (0, _createRouteFromName.default)(name);
  }).join("/");
  var metaKeywords = [].concat(_toConsumableArray(searchTags), [name]).filter(function (item) {
    return item;
  }).join(",");

  _react.default.useEffect(function () {
    prevPage.current = {
      name: name,
      link: pagePath
    };
  }, []);

  _react.default.useEffect(function () {
    /**
     * searchItem - search item for current page;
     * @type SearchDataItem
     */
    var searchItem = {
      redirect: {
        page: pagePath
      },
      label: searchLabel || name,
      description: searchDescription || Object.keys(tags).length && tags[Object.keys[Object.keys(tags)[0]]] || "",
      tags: searchTags || []
    };

    if (!noGenerateAutoSearch) {
      removeSearchItem(prevSearchItem.current);
      prevSearchItem.current = searchItem;
      addSearchItem(searchItem);
    }

    return function () {
      return !noGenerateAutoSearch && removeSearchItem(searchItem);
    };
  }, [searchLabel, searchDescription, name]);

  _react.default.useEffect(function () {
    /**
     * page - page data for auto menu.
     * @type PageData
     */
    var page = {
      name: name,
      link: pagePath,
      path: [].concat(_toConsumableArray(parentPath || []), [name]),
      order: typeof order === "number" ? order : undefined
    };
    prevPage.current = page;
    !noAutoMenu && addPage(page);
    return function () {
      return !noAutoMenu && deletePage(page);
    };
  }, [name]);

  function insertTagCallbacksInChildren(source) {
    return _react.default.Children.map(source, function (child) {
      if (typeof child === "string") return /*#__PURE__*/_react.default.createElement(_Typography.default, {
        className: commonClasses.pageBlock
      }, child);
      return child;
    });
  }

  function makeKeysFromTags() {
    var keys = [];

    for (var key in tags) {
      var _ref2 = tags[key] || {},
          label = _ref2.label,
          _ref = _ref2.ref,
          topOffset = _ref2.topOffset;

      var id = key;
      keys.push({
        id: id,
        label: label,
        ref: _ref,
        topOffset: topOffset
      });
    }

    keys.sort(function (a, b) {
      if (a.topOffset > b.topOffset) return 1;
      if (a.topOffset === b.topOffset) return 0;
      if (a.topOffset < b.topOffset) return -1;
    });
    return keys;
  }

  _react.default.useEffect(function () {
    var newContent = children;

    if (typeof children === "Symbol(react.element)" || Array.isArray(children)) {
      newContent = insertTagCallbacksInChildren(children);
    }

    setContent(newContent);
  }, [children]);

  var setTag = function setTag(key, value) {
    return setTags(function (last) {
      return _objectSpread({}, last, _defineProperty({}, key, value));
    });
  };

  var removeTag = function removeTag(key) {
    return setTags(function (last) {
      var newTags = _.cloneDeep(last);

      delete newTags[key];
      return newTags;
    });
  };

  var withRouter = function withRouter(enable) {
    return function (content) {
      return enable ? /*#__PURE__*/_react.default.createElement(_reactRouterDom.Route, {
        path: "/".concat(pagePath)
      }, content) : content;
    };
  };

  return withRouter(!disableRoute)( /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactHelmetAsync.Helmet, null, /*#__PURE__*/_react.default.createElement("title", null, name), /*#__PURE__*/_react.default.createElement("meta", {
    name: "description",
    content: searchDescription || ""
  }), /*#__PURE__*/_react.default.createElement("meta", {
    name: "keywords",
    content: metaKeywords || ""
  })), /*#__PURE__*/_react.default.createElement(_useTags.TaggingContext.Provider, {
    value: {
      setTag: setTag,
      removeTag: removeTag,
      tags: tags
    }
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true,
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12,
    md: 1
  }), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12,
    md: 8
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    p: (0, _core.isWidthUp)("md", width) ? 1 : 3
  }, content)), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12,
    md: 1
  }), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12,
    md: 2,
    style: {
      position: "relative"
    }
  }, /*#__PURE__*/_react.default.createElement(_NavigationList.default, {
    keys: makeKeysFromTags()
  })), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    className: classes.copyright,
    p: 1
  }, /*#__PURE__*/_react.default.createElement(_Typography.default, null, /*#__PURE__*/_react.default.createElement(_Locale.default, {
    path: "MaterialDocs/copyright/text"
  }))))))));
});

DocsPage.displayName = displayName;
DocsPage.propTypes = {
  // DocsPageProps
  name: _propTypes.default.string,
  searchTags: _propTypes.default.arrayOf(_propTypes.default.string),
  searchLabel: _propTypes.default.string,
  searchDescription: _propTypes.default.string,
  noGenerateAutoSearch: _propTypes.default.bool,
  noAutoMenu: _propTypes.default.bool,
  order: _propTypes.default.number,
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object,
  // Containerable
  children: _propTypes.default.node
};

var _default = (0, _styles2.withStyles)(_styles.styles, {
  name: displayName
})(DocsPage);

exports.default = _default;