"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

var _styles = require("@material-ui/core/styles");

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var styles = function styles(theme) {
  return (0, _styles.createStyles)({
    root: {},
    contentItem: {
      borderLeft: "5px solid rgba(0,0,0,0)",
      "&:hover": {
        borderColor: theme.palette.type === "light" ? theme.palette.lightgrey.main : theme.palette.lightgrey.dark
      }
    },
    contentItemActive: {
      borderColor: theme.palette.type === "light" ? theme.palette.lightgrey.main : theme.palette.lightgrey.dark
    },
    contentLink: {
      textDecoration: "none",
      color: "inherit"
    },
    copyright: {
      backgroundColor: theme.palette.type === "light" ? theme.palette.whitesmoke : theme.palette.whitesmoke.dark,
      color: theme.palette.type === "light" ? theme.palette.lightgrey.main : theme.palette.lightgrey.dark
    },
    typography: {
      overflowWrap: "break-word",
      maxWidth: "calc(10vw - ".concat(theme.spacing(2), "px)")
    },
    navigationList: {
      position: "fixed",
      width: "100%",
      maxHeight: "calc(100vh - ".concat(theme.spacing(16), "px)"),
      overflowY: "auto"
    }
  });
};

exports.styles = styles;