"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _H = _interopRequireDefault(require("../H3"));

var _Code = _interopRequireDefault(require("../Code"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _Collapse = _interopRequireDefault(require("@material-ui/core/Collapse"));

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Code2 = _interopRequireDefault(require("@material-ui/icons/Code"));

var _FileCopy = _interopRequireDefault(require("@material-ui/icons/FileCopy"));

var _MoreVert = _interopRequireDefault(require("@material-ui/icons/MoreVert"));

var _propTypes = _interopRequireWildcard(require("prop-types"));

var _DemoCodeActionValidator = _interopRequireDefault(require("../../validators/DemoCodeActionValidator"));

var _styles2 = require("@material-ui/styles");

var _notistack = require("notistack");

var _commonStyles = require("../../stylesheets/commonStyles");

var _clsx = _interopRequireDefault(require("clsx"));

var _copyToClipboard = _interopRequireDefault(require("../../utils/copyToClipboard"));

var _utils = require("../../utils");

var _hooks = require("../../hooks");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-ExpansionCode";
exports.displayName = displayName;

var ExpansionCode = /*#__PURE__*/_react.default.forwardRef(function ExpansionCode(props, ref) {
  var language = props.language,
      children = props.children,
      name = props.name,
      noTag = props.noTag,
      style = props.style,
      className = props.className,
      _props$collapsedHeigh = props.collapsedHeight,
      collapsedHeight = _props$collapsedHeigh === void 0 ? 100 : _props$collapsedHeigh,
      actions = props.actions,
      classes = props.classes,
      other = _objectWithoutProperties(props, ["language", "children", "name", "noTag", "style", "className", "collapsedHeight", "actions", "classes"]);

  var commonClasses = (0, _commonStyles.useCommonStyles)();

  var _useLang = (0, _hooks.useLang)(),
      lang = _useLang.lang;

  var _useSnackbar = (0, _notistack.useSnackbar)(),
      enqueueSnackbar = _useSnackbar.enqueueSnackbar;

  var _React$useState = _react.default.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      expand = _React$useState2[0],
      setExpand = _React$useState2[1];

  var menuAnchor = _react.default.useRef(null);

  var _React$useState3 = _react.default.useState(false),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      menuOpen = _React$useState4[0],
      setMenuOpen = _React$useState4[1];

  return /*#__PURE__*/_react.default.createElement(_Box.default, {
    className: (0, _clsx.default)(classes.root, commonClasses.pageBlock, className),
    style: style,
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(_Toolbar.default, {
    className: classes.toolbar
  }, actions && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    title: (0, _utils.getFieldFromLang)(lang, "MaterialDocs/ExpansionCode/moreActions")
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    ref: menuAnchor,
    onClick: function onClick(event) {
      return setMenuOpen(true);
    }
  }, /*#__PURE__*/_react.default.createElement(_MoreVert.default, {
    fontSize: "small"
  }))), /*#__PURE__*/_react.default.createElement(_Menu.default, {
    anchorEl: menuAnchor.current,
    getContentAnchorEl: null,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'left'
    },
    keepMounted: true,
    open: menuOpen,
    onClose: function onClose(event) {
      return setMenuOpen(false);
    }
  }, actions.map(function (action) {
    return /*#__PURE__*/_react.default.createElement("a", {
      className: classes.menuButtonLink,
      key: "menu-item-".concat(action.label, " ").concat(action.link),
      href: action.link
    }, /*#__PURE__*/_react.default.createElement(_MenuItem.default, {
      button: true
    }, action.label));
  }))), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    title: (0, _utils.getFieldFromLang)(lang, "MaterialDocs/ExpansionCode/copyToClipboard")
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      (0, _copyToClipboard.default)(children).then(function (res) {
        return enqueueSnackbar((0, _utils.getFieldFromLang)(lang, "MaterialDocs/notices/codeCopied"), {
          variant: "success"
        });
      }).catch(function (error) {
        return enqueueSnackbar((0, _utils.getFieldFromLang)(lang, "MaterialDocs/notices/codeNotCopied"), {
          variant: "error"
        });
      });
    }
  }, /*#__PURE__*/_react.default.createElement(_FileCopy.default, {
    fontSize: "small"
  }))), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    title: (0, _utils.getFieldFromLang)(lang, "MaterialDocs/ExpansionCode/expand")
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick(event) {
      return setExpand(!expand);
    }
  }, /*#__PURE__*/_react.default.createElement(_Code2.default, {
    fontSize: "small"
  }))), name && /*#__PURE__*/_react.default.createElement(_H.default, {
    className: classes.codeName,
    noDivider: true
  }, name)), /*#__PURE__*/_react.default.createElement(_Collapse.default, {
    in: expand,
    collapsedHeight: collapsedHeight,
    className: classes.collapse,
    disableStrictModeCompat: true
  }, /*#__PURE__*/_react.default.createElement(_Code.default, other, children)));
});

ExpansionCode.displayName = displayName;
ExpansionCode.propTypes = {
  // ExpansionCodeProps
  name: _propTypes.default.string,
  noTag: _propTypes.default.bool,
  collapsedHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  actions: (0, _propTypes.arrayOf)(_DemoCodeActionValidator.default),
  // CodeProps
  theme: _propTypes.default.oneOf(["light", "dark", "darcula"]),
  language: _propTypes.default.oneOf(["1c", "abnf", "accesslog", "actionscript", "ada", "angelscript", "apache", "applescript", "arcade", "arduino", "armasm", "asciidoc", "aspectj", "autohotkey", "autoit", "avrasm", "awk", "axapta", "bash", "basic", "bnf", "brainfuck", "c-like", "c", "cal", "capnproto", "ceylon", "clean", "clojure-repl", "clojure", "cmake", "coffeescript", "coq", "cos", "cpp", "crmsh", "crystal", "csharp", "csp", "css", "d", "dart", "delphi", "diff", "django", "dns", "dockerfile", "dos", "dsconfig", "dts", "dust", "ebnf", "elixir", "elm", "erb", "erlang-repl", "erlang", "excel", "fix", "flix", "fortran", "fsharp", "gams", "gauss", "gcode", "gherkin", "glsl", "gml", "go", "golo", "gradle", "groovy", "haml", "handlebars", "haskell", "haxe", "hsp", "htmlbars", "http", "hy", "inform7", "ini", "irpf90", "isbl", "java", "javascript", "jboss-cli", "json", "julia-repl", "julia", "kotlin", "lasso", "latex", "ldif", "leaf", "less", "lisp", "livecodeserver", "livescript", "llvm", "lsl", "lua", "makefile", "markdown", "mathematica", "matlab", "maxima", "mel", "mercury", "mipsasm", "mizar", "mojolicious", "monkey", "moonscript", "n1ql", "nginx", "nim", "nix", "nsis", "objectivec", "ocaml", "openscad", "oxygene", "parser3", "perl", "pf", "pgsql", "php-template", "php", "plaintext", "pony", "powershell", "processing", "profile", "prolog", "properties", "protobuf", "puppet", "purebasic", "python-repl", "python", "q", "qml", "r", "reasonml", "rib", "roboconf", "routeros", "rsl", "ruby", "ruleslanguage", "rust", "sas", "scala", "scheme", "scilab", "scss", "shell", "smali", "smalltalk", "sml", "sqf", "sql", "stan", "stata", "step21", "stylus", "subunit", "swift", "taggerscript", "tap", "tcl", "thrift", "tp", "twig", "typescript", "vala", "vbnet", "vbscript-html", "vbscript", "verilog", "vhdl", "vim", "x86asm", "xl", "xml", "xquery", "yaml", "zephir"]),
  children: _propTypes.default.string,
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object
};

var _default = (0, _styles2.withStyles)(_styles.styles, {
  name: displayName
})(ExpansionCode);

exports.default = _default;