/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */

/// <reference types="react" />
import {TagableProps} from "../Tagable/Tagable";

export const displayName: string;

export interface H2Props
    extends TagableProps {
}

/**
 * H2 - react component, designed to create h2 header.
 * @param {TagableProps} props
 * @constructor
 * @see https://material-docs.com/component-apis/h2
 * @example
 * <H2>I am h2 header with tag</H2>
 */
export default function H2(props: H2Props): JSX.Element;
