"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _core = require("@material-ui/core");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = _interopRequireDefault(require("@material-ui/styles/withStyles"));

var _hooks = require("../../hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-Link";
exports.displayName = displayName;

var Link = /*#__PURE__*/_react.default.forwardRef(function Link(props, ref) {
  var children = props.children,
      page = props.page,
      href = props.href,
      other = _objectWithoutProperties(props, ["children", "page", "href"]);

  var _useSwitchPage = (0, _hooks.useSwitchPage)(),
      switchPage = _useSwitchPage.switchPage;

  function handleClick(event) {
    switchPage(page);
  }

  return /*#__PURE__*/_react.default.createElement(_core.Link, _extends({
    href: page ? null : href,
    ref: ref,
    onClick: handleClick
  }, other), children);
});

Link.displayName = displayName;
Link.propTypes = {
  page: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.string)]),
  href: _propTypes.default.string,
  children: _propTypes.default.node
};

var _default = (0, _withStyles.default)(_styles.styles, {
  name: displayName
})(Link);

exports.default = _default;