"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _commonStyles = require("../../stylesheets/commonStyles");

var _styles2 = require("@material-ui/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-List";
exports.displayName = displayName;

var List = /*#__PURE__*/_react.default.forwardRef(function List(props, ref) {
  var children = props.children,
      className = props.className,
      style = props.style,
      image = props.image,
      classes = props.classes,
      other = _objectWithoutProperties(props, ["children", "className", "style", "image", "classes"]);

  var commonClasses = (0, _commonStyles.useCommonStyles)();
  return /*#__PURE__*/_react.default.createElement("ul", _extends({}, other, {
    ref: ref,
    className: (0, _clsx.default)(commonClasses.pageBlock, classes.root, className),
    style: style
  }), children);
});

List.displayName = displayName;
List.propTypes = {
  // ListProps
  image: _propTypes.default.string,
  styling: _propTypes.default.oneOf(["inside", "outside", "inherit", "revert", "unset"]),
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object,
  // Containerable
  children: _propTypes.default.node
};

var _default = (0, _styles2.withStyles)(_styles.styles, {
  name: displayName
})(List);

exports.default = _default;