"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SearchContext = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var SearchContext = /*#__PURE__*/_react.default.createContext({
  /**
   * addSearchItem - adds SearchDataItem to storage.
   * @function
   * @param {SearchDataItem} item
   */
  addSearchItem: function addSearchItem(item) {},

  /**
   * removeSearchItem - removes SearchDataItem to storage.
   * @function
   * @param {SearchDataItem} item
   */
  removeSearchItem: function removeSearchItem(item) {},

  /**
   * getSearchData - returns search data list.
   * @type SearchDataItem[]
   */
  getSearchData: function getSearchData() {}
});

exports.SearchContext = SearchContext;

var useSearch = function useSearch() {
  return _react.default.useContext(SearchContext);
};

var _default = useSearch;
exports.default = _default;