"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateMaterialDocsFromMarkdown;

var _react = _interopRequireDefault(require("react"));

var _Header = _interopRequireDefault(require("../components/Header"));

var _List = _interopRequireDefault(require("../components/List/List"));

var _ListItem = _interopRequireDefault(require("../components/ListItem/ListItem"));

var _Code = _interopRequireDefault(require("../components/Code/Code"));

var _Link = _interopRequireDefault(require("../components/Link"));

var _Bold = _interopRequireDefault(require("../components/Bold/Bold"));

var _Italic = _interopRequireDefault(require("../components/Italic/Italic"));

var _Image = _interopRequireDefault(require("../components/Image/Image"));

var _Table = _interopRequireDefault(require("../components/Table"));

var _TableHead = _interopRequireDefault(require("../components/TableHead"));

var _TableBody = _interopRequireDefault(require("../components/TableBody"));

var _TableRow = _interopRequireDefault(require("../components/TableRow"));

var _TableCell = _interopRequireDefault(require("../components/TableCell"));

var _Block = _interopRequireDefault(require("../components/Block/Block"));

var _CodeSpan = _interopRequireDefault(require("../components/CodeSpan/CodeSpan"));

var _ExpansionCode = _interopRequireDefault(require("../components/ExpansionCode/ExpansionCode"));

var _DemoWithCode = _interopRequireDefault(require("../components/DemoWithCode/DemoWithCode"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _marked = _interopRequireWildcard(require("marked"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _createForOfIteratorHelper(o) { if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) { var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var it, normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * fixShieldedText - fixes bug with shielded symbols in text after using lexer.
 * @function
 * @param {string} text
 * @return {string}
 */
function unescape(text) {
  if (typeof text !== "string") return "";
  return text.replace(/&#39;+/g, "'").replace(/&quot;+/g, "\"").replace(/&lt;+/g, "<").replace(/&gt;/g, ">");
}
/**
 * TokenizerWithNoScreening - marked tokenized with disabled escaping.
 */


var TokenizerWithNoScreening = /*#__PURE__*/function (_Tokenizer) {
  _inherits(TokenizerWithNoScreening, _Tokenizer);

  var _super = _createSuper(TokenizerWithNoScreening);

  function TokenizerWithNoScreening() {
    _classCallCheck(this, TokenizerWithNoScreening);

    return _super.apply(this, arguments);
  }

  _createClass(TokenizerWithNoScreening, [{
    key: "codespan",
    value: function codespan(src) {
      var cap = this.rules.inline.code.exec(src);

      if (cap) {
        var text = cap[2].replace(/\n/g, ' ');
        var hasNonSpaceChars = /[^ ]/.test(text);
        var hasSpaceCharsOnBothEnds = text.startsWith(' ') && text.endsWith(' ');

        if (hasNonSpaceChars && hasSpaceCharsOnBothEnds) {
          text = text.substring(1, text.length - 1);
        }

        return {
          type: 'codespan',
          raw: cap[0],
          text: text
        };
      }
    }
  }, {
    key: "inlineText",
    value: function inlineText(src, inRawBlock, smartypants) {
      var cap = this.rules.inline.text.exec(src);

      if (cap) {
        var text = cap[0];
        return {
          type: 'text',
          raw: cap[0],
          text: text
        };
      }
    }
  }, {
    key: "url",
    value: function url(src, mangle) {
      var cap;

      if (cap = this.rules.inline.url.exec(src)) {
        var text, href;

        if (cap[2] === '@') {
          text = this.options.mangle ? mangle(cap[0]) : cap[0];
          href = 'mailto:' + text;
        } else {
          // do extended autolink path validation
          var prevCapZero;

          do {
            prevCapZero = cap[0];
            cap[0] = this.rules.inline._backpedal.exec(cap[0])[0];
          } while (prevCapZero !== cap[0]);

          text = cap[0];

          if (cap[1] === 'www.') {
            href = 'http://' + text;
          } else {
            href = text;
          }
        }

        return {
          type: 'link',
          raw: cap[0],
          text: text,
          href: href,
          tokens: [{
            type: 'text',
            raw: text,
            text: text
          }]
        };
      }
    }
  }]);

  return TokenizerWithNoScreening;
}(_marked.Tokenizer);
/**
 * generateTextToken - fix for marked incorrect work. Replaces string which contains linebreaks with token.
 * @param {string} text Text to process.
 * @return {{type: string, text?: string}[]}
 */


function generateTextToken(text) {
  var lines = text.split("\n");
  var tokens = [];

  var _iterator = _createForOfIteratorHelper(lines),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var line = _step.value;
      tokens.push({
        type: "text",
        text: line
      });
      tokens.push({
        type: "br"
      });
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  if (tokens.length) delete tokens[tokens.length - 1];
  return tokens;
}

function generateMaterialDocsFromMarkdown(input) {
  var storage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var key = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
  var options = arguments.length > 3 ? arguments[3] : undefined;
  if (!(typeof input === "string" || _typeof(input) === "object")) throw new TypeError("MaterialDocs: incorrect type of \"input\" param, expected \"object | string\", got \"".concat(_typeof(input), "\""));
  if (_typeof(storage) !== "object") throw new TypeError("MaterialDocs: incorrect type of \"storage\" param, expected \"object | string\", got \"".concat(_typeof(storage), "\""));

  if (_typeof(key) === "object" && !options) {
    options = key;
    key = 1;
  }

  if (options && _typeof(options) !== "object") throw new TypeError("MaterialDocs: incorrect type of \"options\" param, expected \"object\", got \"".concat(_typeof(options), "\""));
  if (!options) options = {};
  var tokens = input;

  if (typeof input === "string") {
    var tokenizer = new TokenizerWithNoScreening();
    var lexer = new _marked.Lexer({
      tokenizer: tokenizer,
      gfm: true
    });
    tokens = lexer.lex(input);
  }

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
    key: "markdown-token-".concat(key)
  }, tokens.map(function (token, tokenId) {
    switch (token.type) {
      case "html":
        return /*#__PURE__*/_react.default.createElement(_Typography.default, {
          key: "paragraph-token-".concat(tokenId),
          variant: options.typographyInheritSize ? "inherit" : "body1",
          variantMapping: {
            body1: "span",
            body2: "span"
          }
        }, token.text);

      case "heading":
        return /*#__PURE__*/_react.default.createElement(_Header.default, {
          heading: token.depth,
          key: "heading-token-".concat(tokenId)
        }, token.tokens && generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key));

      case "text":
        {
          if (token.tokens) {
            return generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key);
          } else {
            if (token.text.includes("\n")) {
              return generateMaterialDocsFromMarkdown(generateTextToken(token.text), storage, tokenId + key);
            } else {
              return /*#__PURE__*/_react.default.createElement("span", {
                key: "text-token-".concat(tokenId)
              }, token.text);
            }
          }
        }

      case "paragraph":
        return /*#__PURE__*/_react.default.createElement(_Typography.default, {
          key: "paragraph-token-".concat(tokenId),
          variant: options.typographyInheritSize ? "inherit" : "body1",
          variantMapping: {
            body1: "span",
            body2: "span"
          }
        }, token.tokens && generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key));

      case "list":
        return /*#__PURE__*/_react.default.createElement(_List.default, {
          key: "list-token-".concat(tokenId)
        }, token.items && generateMaterialDocsFromMarkdown(token.items, storage, tokenId + key));

      case "list_item":
        return /*#__PURE__*/_react.default.createElement(_ListItem.default, {
          key: "list-item-token-".concat(tokenId)
        }, token.tokens && generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key));

      case "code":
        try {
          var setting = JSON.parse(token.lang);
          var _setting$type = setting.type,
              type = _setting$type === void 0 ? "code" : _setting$type,
              _setting$language = setting.language,
              language = _setting$language === void 0 ? "javascript" : _setting$language;
          if (type !== "expansion-code" && type !== "code" && type !== "demo-with-code") console.error("MaterialDocs: incorrect type of code block setting field \"type\", expected \"expansion-code | code | demo-with-code\" got ".concat(type));
          if (language && typeof language !== "string") console.error("MaterialDocs: incorrect type of code block setting field \"language\", expected \"string\" got ".concat(_typeof(language)));

          switch (setting.type) {
            case "expansion-code":
              {
                var name = setting.name,
                    collapsedHeight = setting.collapsedHeight,
                    theme = setting.theme,
                    _type = setting.type,
                    other = _objectWithoutProperties(setting, ["name", "collapsedHeight", "theme", "type"]);

                if (theme && typeof theme !== "string") console.error("MaterialDocs: incorrect type of code block setting field \"theme\", expected \"string\" got ".concat(_typeof(theme)));
                return /*#__PURE__*/_react.default.createElement(_ExpansionCode.default, _extends({
                  language: language,
                  name: name,
                  collapsedHeight: collapsedHeight,
                  key: "code-token-".concat(tokenId),
                  theme: theme
                }, other), token.text);
                break;
              }

            case "demo-with-code":
              {
                var defaultExpanded = setting.defaultExpanded,
                    text = setting.text,
                    _name = setting.name,
                    _theme = setting.theme,
                    _type2 = setting.type,
                    _other = _objectWithoutProperties(setting, ["defaultExpanded", "text", "name", "theme", "type"]);

                if (_theme && typeof _theme !== "string") console.error("MaterialDocs: incorrect type of code block setting field \"theme\", expected \"string\" got ".concat(_typeof(_theme)));
                if (text && typeof text !== "string") console.error("MaterialDocs: incorrect type of code block setting field \"text\", expected \"string\" got ".concat(_typeof(text)));
                var Demo = null;

                if (typeof setting.demo === "string") {
                  Demo = storage[setting.demo];
                }

                return /*#__PURE__*/_react.default.createElement(_DemoWithCode.default, _extends({
                  language: language,
                  defaultExpanded: defaultExpanded,
                  code: token.text,
                  name: _name,
                  theme: _theme,
                  key: "code-token-".concat(tokenId)
                }, _other), Demo || null);
                break;
              }

            default:
              {
                var _theme2 = setting.theme,
                    _type3 = setting.type,
                    _other2 = _objectWithoutProperties(setting, ["theme", "type"]);

                if (_theme2 && typeof _theme2 !== "string") console.error("MaterialDocs: incorrect type of code block setting field \"theme\", expected \"string\" got ".concat(_typeof(_theme2)));
                return /*#__PURE__*/_react.default.createElement(_Code.default, _extends({
                  language: language,
                  key: "code-token-".concat(tokenId),
                  theme: _theme2
                }, _other2), token.text);
              }
          }
        } catch (error) {
          if (error instanceof SyntaxError) {
            return /*#__PURE__*/_react.default.createElement(_Code.default, {
              language: token.lang,
              key: "code-token-".concat(tokenId)
            }, token.text);
          } else {
            throw error;
          }
        }

        return /*#__PURE__*/_react.default.createElement(_Code.default, {
          language: token.lang,
          key: "code-token-".concat(tokenId)
        }, token.text);

      case "codespan":
        return /*#__PURE__*/_react.default.createElement(_CodeSpan.default, {
          key: "codespan-token-".concat(tokenId)
        }, token.text);

      case "link":
        {
          var href = token.href,
              _text = token.text,
              _tokens = token.tokens;
          var settings = {};

          try {
            settings = JSON.parse(unescape(_text));
            if (typeof settings.text === "string") settings.tokens = _marked.default.lexer(settings.text);
          } catch (e) {
            settings = {
              tokens: _tokens
            };
          } finally {
            settings.href = href;
          }

          return /*#__PURE__*/_react.default.createElement(_Link.default, {
            href: settings.href,
            page: settings.page,
            key: "link-token-".concat(tokenId)
          }, settings.tokens && generateMaterialDocsFromMarkdown(settings.tokens, storage, tokenId + key));
        }

      case "br":
        return /*#__PURE__*/_react.default.createElement("br", {
          key: "br-token-".concat(tokenId)
        });

      case "hr":
        return /*#__PURE__*/_react.default.createElement(_Divider.default, {
          key: "hr-token-".concat(tokenId)
        });

      case "strong":
        return /*#__PURE__*/_react.default.createElement(_Bold.default, {
          key: "strong-token-".concat(tokenId)
        }, token.tokens && generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key));

      case "em":
        return /*#__PURE__*/_react.default.createElement(_Italic.default, {
          key: "em-token-".concat(tokenId)
        }, token.tokens && generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key));

      case "image":
        {
          var _href = token.href,
              _text2 = token.text;
          var _settings = {
            src: _href,
            alt: _text2
          };

          try {
            _settings = JSON.parse(unescape(_text2));
          } catch (e) {}

          return /*#__PURE__*/_react.default.createElement(_Image.default, _extends({}, _settings, {
            src: _settings.src,
            alt: _settings.alt,
            key: "image-token-".concat(tokenId)
          }));
        }

      case "table":
        var header = token.tokens.header;
        var cells = token.tokens.cells;
        return /*#__PURE__*/_react.default.createElement(_Table.default, {
          key: "table-token-".concat(tokenId)
        }, /*#__PURE__*/_react.default.createElement(_TableHead.default, null, /*#__PURE__*/_react.default.createElement(_TableRow.default, null, header.map(function (cell, index) {
          return /*#__PURE__*/_react.default.createElement(_TableCell.default, {
            key: "markdown-table-head-cell-".concat(index)
          }, /*#__PURE__*/_react.default.createElement(_Bold.default, null, cell && generateMaterialDocsFromMarkdown(cell, storage, tokenId + key)));
        }))), /*#__PURE__*/_react.default.createElement(_TableBody.default, null, cells.map(function (row, index) {
          return /*#__PURE__*/_react.default.createElement(_TableRow.default, {
            key: "markdown-table-row-".concat(index)
          }, row.map(function (cell, index) {
            return /*#__PURE__*/_react.default.createElement(_TableCell.default, {
              key: "markdown-table-cell-".concat(index)
            }, cell && generateMaterialDocsFromMarkdown(cell, storage, tokenId + key));
          }));
        })));

      case "blockquote":
        return /*#__PURE__*/_react.default.createElement(_Block.default, {
          key: "blockquote-token-".concat(tokenId)
        }, token.tokens && generateMaterialDocsFromMarkdown(token.tokens, storage, tokenId + key));

      default:
        return null;
    }
  }));
}